# Ore Runneth Evermore (O.R.E)

The purpose of this mod is to create a means to automatically respawn ores, such as silver and copper. It works by removing the natural generation of ore resources and generates these as locations. Then using Upgrade World (listed as a dependency), use location reset commands to reset the ore locations and terrain, refreshing the world to its pristine condition.  

## Features:
- Adjust quantity, altitude and distance between ore deposits in the config to customize your experience. Create a world with few deposits, encouraging more exploration, or create a world with many locations. 

- Set quantity to 0 to remove a resource entirely, like the hidden mudpiles in the swamps.

- Terrain is reset to return the area to its original look. 

- As these are locations, they can be modified using [Expand World](https://valheim.thunderstore.io/package/JereKuusela/Expand_World_Data/) (see Drawback for a slight bug)

- Required only on the server. 

## Drawbacks:
- These ore locations are prioritized first amung other locations, and thus, due to vanilla's limit of locations per zone, the more ore locations you add, the less other locations may be generated. For example, the more silver vein locations, the less mountain wells are generated.

- When the terrain is reset, the vegetation isn't, which in the case of copper, creates a rather obvious clearing where the copper node sits. 

- When using Expand World, the exterior radius in the `locations.yaml` gets set to 20. This will cause many of the locations to not generate and many other locations to not generate. 

Please change the exterior radius to the following: 
```
coppervein_loc = 10
tinvein_loc = 2
ironvein_loc = 5
silvervein_loc = 10
```

## How to use:
 
### Location Prefabs:
```
tinvein_loc
coppervein_loc
silvervein_loc
ironvein_loc
```

### Upgrade World Commands:
*the `force` property will remove player structures from the reset area. You may remove the property to run reset based on Upgrade World's safe zone.* 
```
locations_reset tinvein_loc terrain=5 start force
locations_reset coppervein_loc terrain=40 start force
locations_reset silvervein_loc terrain=20 start force
locations_reset ironvein_loc terrain=20 start force
```

### [Cron Job - for automation](https://valheim.thunderstore.io/package/JereKuusela/Cron_Job/)
Place these in the jobs property in the cron.yaml. The following will reset ore locations at 2 AM (for timezone given) every three real life days. 
```
jobs:
  - command: locations_reset tinvein_loc terrain=5 start force
    schedule: "0 2 */3 * *"
    inactive: 0
  - command: locations_reset coppervein_loc terrain=40 start force
    schedule: "0 2 */3 * *"
    inactive: 0
  - command: locations_reset silvervein_loc terrain=20 start force
    schedule: "0 2 */3 * *"
    inactive: 0
  - command: locations_reset ironvein_loc terrain=20 start force
    schedule: "0 2 */3 * *"
    inactive: 0
```

## Changelog
1.0.0
- Reupload to ensure proper version
- updated Readme

0.0.1
- Initial Upload